//+------------------------------------------------------------------+
//|                                               Equity_virtual.mq4 |
//|                                         Copyright  2009, Xupypr |
//|                              http://www.mql4.com/ru/users/Xupypr |
//|                                               25.04.2009 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Xupypr"
#property link      "http://www.mql4.com/ru/users/Xupypr"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 SteelBlue
#property indicator_color3 OrangeRed
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_level1 0

extern datetime Time_Begin=D'2009.01.01 00:00'; //    
extern datetime Time_End=D'2010.01.01 00:00';   //    
extern int    Time_Refresh=3;  //         
extern int    Deposit=10000;   //  
extern double Default_Lot=0.1; //    ,        
extern bool   Use_MM=false;    //  Money Management (    )
extern bool   Show_Total=true; //   
extern bool   Show_Buy=false;  //    buy
extern bool   Show_Sell=false; //    sell
extern bool   Show_Info=false; //   
extern bool   Use_M1=false;    //      

//               !!!
//      .
//      openbuyN  opensellN,  N -   .
//        (EURUSD GBPUSD).
// " "      (EURUSD1 GBPUSD0.7).
//     ,    .
//         .
//    closeN    ,  N -   .

int      Total,Tick;
string   ShortName;
double   BuyBalance,SellBalance,PrevEquity,TotalEquity[],BuyEquity[],SellEquity[];
double   MaxPeak,MaxProfit;
double   AbsDrawdown,MaxDrawdown,RelDrawdown,Drawdown,RecoveryFactor;

int      OpenBar[];    //   
int      CloseBar[];   //   
int      Type[];       //  
string   Instrument[]; // 
double   Lots[];       //  
double   OpenPrice[];  //  
double   ClosePrice[]; //  

//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
int init()
{
 SetIndexBuffer(0,TotalEquity);
 SetIndexLabel(0,"Total");
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(1,BuyEquity);
 SetIndexLabel(1,"Buy");
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(2,SellEquity);
 SetIndexLabel(2,"Sell");
 SetIndexStyle(2,DRAW_LINE);
 ShortName="Equity";
 if (Show_Total) ShortName=StringConcatenate(ShortName," Total");
 if (Show_Buy)   ShortName=StringConcatenate(ShortName," Buy");
 if (Show_Sell)  ShortName=StringConcatenate(ShortName," Sell");
 IndicatorShortName(ShortName);
 IndicatorDigits(2);
 return(0);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator deinitialization function                                |
//+----------------------------------------------------------------------------+
int deinit()
{
 int window=WindowFind(ShortName);
 if (window!=-1) ObjectsDeleteAll(window);
 return(0);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
int start()
{
 string objname,text;
 static bool alert=false;
 static string minfosymbols="";
 double buyprofitloss,sellprofitloss,spread,lotsize;
 int bar,i,j,start,finish,objtotal;
 datetime time;

 if (GetTickCount()-Tick>Time_Refresh*1000) Tick=GetTickCount();
 else return(0);
 Total=0;
 objtotal=ObjectsTotal();
 for (i=0;i<objtotal;i++)
 {
  objname=ObjectName(i);
  time=ObjectGet(objname,OBJPROP_TIME1);
  if (time>TimeCurrent() || time<Time_Begin || time>Time_End) continue;
  if (StringFind(objname,"openbuy")!=-1) SetOrder(objname,OP_BUY);
  if (StringFind(objname,"opensell")!=-1) SetOrder(objname,OP_SELL);
 }
 ArrayInitialize(TotalEquity,EMPTY_VALUE);
 ArrayInitialize(BuyEquity,EMPTY_VALUE);
 ArrayInitialize(SellEquity,EMPTY_VALUE);
 if (Total==0)
 {
  if (!alert)
  {
   Alert("      !");
   alert=true;
  }
  return(0);
 }
 alert=false;
 MaxPeak=0.0;
 MaxProfit=0.0;
 AbsDrawdown=0.0;
 MaxDrawdown=0.0;
 RelDrawdown=0.0;
 BuyBalance=0.0;
 SellBalance=0.0;
 PrevEquity=Deposit;
 start=OpenBar[ArrayMaximum(OpenBar)];
 finish=iBarShift(NULL,0,Time_End);
 for (i=start;i>=finish;i--)
 {
  buyprofitloss=0.0;
  sellprofitloss=0.0;
  for (j=0;j<Total;j++)
  {
   if (OpenBar[j]>=i && CloseBar[j]<=i)
   {
    if (MarketInfo(Instrument[j],MODE_POINT)==0)
    {
     if (StringFind(minfosymbols,Instrument[j])==-1)
     {
      Alert("     "+Instrument[j]);
      minfosymbols=StringConcatenate(minfosymbols," ",Instrument[j]);
     }
     continue;
    }
    bar=iBarShift(Instrument[j],0,Time[i]);
    lotsize=LotSize(Instrument[j],Time[i]);
    if (Use_MM && OpenBar[j]==i) Lots[j]=NormalizeDouble(PrevEquity/1000*Lots[j],2);
    if (Type[j]==OP_BUY)
    {
     if (CloseBar[j]==i && ClosePrice[j]!=0) BuyBalance+=(iClose(Instrument[j],0,bar)-OpenPrice[j])*Lots[j]*lotsize;
     else buyprofitloss+=(iClose(Instrument[j],0,bar)-OpenPrice[j])*Lots[j]*lotsize;
    } 
    else
    {
     spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
     if (CloseBar[j]==i && ClosePrice[j]!=0) SellBalance+=(OpenPrice[j]-iClose(Instrument[j],0,bar)-spread)*Lots[j]*lotsize;
     else sellprofitloss+=(OpenPrice[j]-iClose(Instrument[j],0,bar)-spread)*Lots[j]*lotsize;
    }
   }
  }
  PrevEquity=NormalizeDouble(Deposit+BuyBalance+SellBalance+buyprofitloss+sellprofitloss,2);
  if (Show_Total) TotalEquity[i]=PrevEquity;
  if (Show_Buy)   BuyEquity[i]=NormalizeDouble(Deposit+BuyBalance+buyprofitloss,2);
  if (Show_Sell)  SellEquity[i]=NormalizeDouble(Deposit+SellBalance+sellprofitloss,2);
  if (Show_Info)  Drawdown(PrevEquity);
 }
 if (Show_Total) SetLevelValue(1,TotalEquity[0]);
 if (Show_Buy)   SetLevelValue(2,BuyEquity[0]);
 if (Show_Sell)  SetLevelValue(3,SellEquity[0]);
 if (Show_Info)
 {
  objname="Absolute Drawdown";
  text=StringConcatenate(objname,": ",DoubleToStr(AbsDrawdown,2));
  LabelCreate(objname,text,10);
  if (MaxPeak>0)
  {
   objname="Maximal Drawdown";
   text=StringConcatenate(objname,": ",DoubleToStr(MaxDrawdown,2)," (",DoubleToStr(100*MaxDrawdown/MaxPeak,2),"%)");
   LabelCreate(objname,text,30);
  }
  objname="Relative Drawdown";
  text=StringConcatenate(objname,": ",DoubleToStr(RelDrawdown,2),"% (",DoubleToStr(Drawdown,2),")");
  LabelCreate(objname,text,50);
  if (MaxDrawdown>0)
  {
   objname="Recovery Factor";
   RecoveryFactor=TotalEquity[0]/MaxDrawdown;
   text=StringConcatenate(objname,": ",DoubleToStr(RecoveryFactor,2));
   LabelCreate(objname,text,70);
  }
 }
 return(0);
}
//+----------------------------------------------------------------------------+
//|                                                      |
//+----------------------------------------------------------------------------+
void LabelCreate(string name, string str, int y)
{
 if (ObjectFind(name)==-1)
 {
  int window=WindowFind(ShortName);
  ObjectCreate(name,OBJ_LABEL,window,0,0);
  ObjectSet(name,OBJPROP_XDISTANCE,10);
  ObjectSet(name,OBJPROP_YDISTANCE,y);
  ObjectSet(name,OBJPROP_CORNER,1);
  ObjectSet(name,OBJPROP_COLOR,SlateGray);
 }
 ObjectSetText(name,str);
}
//+----------------------------------------------------------------------------+
//|                                                              |
//+----------------------------------------------------------------------------+
void Drawdown(double equity)
{
 double relative;
 if (AbsDrawdown<Deposit-equity) AbsDrawdown=Deposit-equity;
 if (equity>MaxProfit) MaxProfit=equity;
 if (MaxDrawdown<MaxProfit-equity)
 {
  MaxDrawdown=MaxProfit-equity;
  MaxPeak=MaxProfit;
  if (MaxPeak>0)
  {
   relative=100*MaxDrawdown/MaxPeak;
   if (RelDrawdown<relative)
   {
    RelDrawdown=relative;
    Drawdown=MaxDrawdown;
   }
  }
 }
}
//+----------------------------------------------------------------------------+
//|                                                 |
//+----------------------------------------------------------------------------+
double LotSize(string symbol, datetime tbar)
{
 double size,close1,close2;
 string BQ,currency=AccountCurrency();
 if (currency=="") currency="USD";
 switch (MarketInfo(symbol,MODE_PROFITCALCMODE))
 {
  case 0:
  {
   int sbar=iBarShift(symbol,0,tbar);
   size=MarketInfo(symbol,MODE_LOTSIZE);
   if (StringSubstr(symbol,3,3)=="USD") break;
   if (StringSubstr(symbol,0,3)=="USD")
   {
    close1=iClose(symbol,0,sbar);
    if (close1>0) size=size/close1;
   }
   else
   {
    BQ=StringSubstr(symbol,0,3)+"USD";
    if (iClose(BQ,0,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
    if (iClose(BQ,0,0)==0) break;
    int BQbar=iBarShift(BQ,0,tbar);
    close1=iClose(symbol,0,sbar);
    close2=iClose(BQ,0,BQbar);
    if (close1>0 && close2>0)
    {
     if (StringSubstr(BQ,0,3)=="USD") size=size/close2/close1;
     else size=size*close2/close1;
    }
   }
  } break;
  case 1: size=MarketInfo(symbol,MODE_LOTSIZE); break;
  case 2: size=MarketInfo(symbol,MODE_TICKVALUE)/MarketInfo(symbol,MODE_TICKSIZE);
 }
 if (currency!="USD")
 {
  BQ=currency+"USD";
  if (iClose(BQ,0,0)==0)
  {
   BQ="USD"+currency;
   close1=iClose(BQ,0,iBarShift(BQ,0,tbar));
   if (close1>0) size*=close1;
  }
  else
  {
   close1=iClose(BQ,0,iBarShift(BQ,0,tbar));
   if (close1>0) size/=close1;
  }
 }
 return(size);
}
//+----------------------------------------------------------------------------+
//|                                                   |
//+----------------------------------------------------------------------------+
void SetOrder(string name, int cmd)
{
 datetime timeopen,timeclose;
 string number;
 int timeframe,length,pos,end;
 
 timeopen=ObjectGet(name,OBJPROP_TIME1);
 if (cmd==OP_BUY) number=StringSubstr(name,7);
 else number=StringSubstr(name,8);
 length=StringLen(ObjectDescription(name));
 pos=0;
 while (pos<length)
 {
  Total++;
  ArrayResize(OpenBar,Total);
  ArrayResize(Instrument,Total);
  ArrayResize(Type,Total);
  ArrayResize(OpenPrice,Total);
  ArrayResize(Lots,Total);
  ArrayResize(CloseBar,Total);
  ArrayResize(ClosePrice,Total);
  OpenBar[Total-1]=iBarShift(NULL,0,timeopen);
  Instrument[Total-1]=StringSubstr(ObjectDescription(name),pos,6);
  pos+=6;
  Type[Total-1]=cmd;
  if (Use_M1) timeframe=PERIOD_M1;
  else timeframe=0;
  OpenPrice[Total-1]=iOpen(Instrument[Total-1],timeframe,iBarShift(Instrument[Total-1],timeframe,timeopen));
  if (cmd==OP_BUY) OpenPrice[Total-1]+=MarketInfo(Instrument[Total-1],MODE_POINT)*MarketInfo(Instrument[Total-1],MODE_SPREAD);
  if (StringGetChar(ObjectDescription(name),pos)==32 || (length-1)<pos) Lots[Total-1]=Default_Lot;
  else
  {
   end=0;
   while(StringGetChar(ObjectDescription(name),pos+end)!=32)
   {
    if ((length-1)<pos+end) break;
    end++;
   }
   Lots[Total-1]=StrToDouble(StringSubstr(ObjectDescription(name),pos,pos+end));
   pos+=end;
  }
  pos++;
  if (ObjectFind("close"+number)!=-1)
  {
   timeclose=ObjectGet("close"+number,OBJPROP_TIME1);
   CloseBar[Total-1]=iBarShift(NULL,0,timeclose);
   ClosePrice[Total-1]=iOpen(Instrument[Total-1],timeframe,iBarShift(Instrument[Total-1],timeframe,timeclose));
  }
  else
  {
   CloseBar[Total-1]=0;
   ClosePrice[Total-1]=0;
  }
 }
}
//+----------------------------------------------------------------------------+